package me.lortseam.uglyscoreboardfix;

import io.github.prospector.modmenu.api.ModMenuApi;
import lombok.Getter;
import me.lortseam.completeconfig.CompleteConfig;
import me.lortseam.completeconfig.ConfigManager;
import me.lortseam.completeconfig.api.ConfigCategory;
import me.lortseam.completeconfig.api.ConfigEntry;
import net.fabricmc.api.ClientModInitializer;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.scoreboard.ScoreboardObjective;
import net.minecraft.scoreboard.ScoreboardPlayerScore;

@Environment(EnvType.CLIENT)
public class UglyScoreboardFix implements ClientModInitializer, ConfigCategory, ModMenuApi {

    private static final String MOD_ID = "uglyscoreboardfix";
    @Getter
    private static UglyScoreboardFix instance;

    @Getter
    private ConfigManager configManager;
    @ConfigEntry
    private boolean enabled = true;
    @ConfigEntry
    private boolean consecutiveOrderOnly = true;

    @Override
    public void onInitializeClient() {
        instance = this;
        configManager = CompleteConfig.register(MOD_ID);
        configManager.register(this);
    }

    public boolean shouldHideScores(ScoreboardObjective objective) {
        if (!enabled) {
            return false;
        }
        if (consecutiveOrderOnly) {
            int[] scores = objective.getScoreboard().getAllPlayerScores(objective).stream().mapToInt(ScoreboardPlayerScore::getScore).toArray();
            if (scores.length >= 2) {
                for (int i = 1; i < scores.length; i++) {
                    if (scores[i - 1] + 1 != scores[i]) {
                        return false;
                    }
                }
            }
        }
        return true;
    }

}
